package com.duanledexianxianxian.demo.service;

import com.duanledexianxianxian.demo.domain.dto.MenuDTO;
import com.duanledexianxianxian.demo.domain.entity.Menu;
import com.baomidou.mybatisplus.extension.service.IService;
import com.duanledexianxianxian.demo.domain.model.query.MenuForm;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 * 菜单表 服务类
 * </p>
 *
 * @author duanledexianxianxian
 * @since 2020 -03-19
 */
public interface IMenuService extends IService<Menu> {

    /**
     * Add menu long.
     *
     * @param form the form
     * @return the long
     */
    Long addMenu(MenuForm form);

    /**
     * Edit menu boolean.
     *
     * @param form the form
     * @return the boolean
     */
    Boolean editMenu(MenuForm form);

    /**
     * Delete menu boolean.
     *
     * @param menuId the menu id
     * @return the boolean
     */
    Boolean deleteMenu(Long menuId);


    /**
     * Gets user menu list.
     *
     * @param userId the user id
     * @return the user menu list
     */
    List<MenuDTO> getUserMenuList(Long userId);

}
